%global eclipse_dropin   %{_datadir}/eclipse/dropins

%global git_tag R2_10_1

Name:      eclipse-xsd
Version:   2.10.1
Release:   1%{?dist}
Summary:   XML Schema Definition (XSD) Eclipse plug-in
License:   EPL
URL:       http://www.eclipse.org/modeling/mdt/?project=xsd

Source0:   http://git.eclipse.org/c/xsd/org.eclipse.xsd.git/snapshot/org.eclipse.xsd-%{git_tag}.tar.bz2

# Build with maven/tycho instead of pdebuild, these patches have been sent upstream, see:
# https://bugs.eclipse.org/bugs/show_bug.cgi?id=438418
Patch0:    0002-Migrate-to-shared-license.patch
Patch1:    0003-438418-Migrate-to-tycho-build.patch

BuildArch:        noarch

BuildRequires:    tycho
BuildRequires:    tycho-extras
BuildRequires:    feclipse-maven-plugin
BuildRequires:    eclipse-pde >= 1:4.4.0
BuildRequires:    eclipse-emf-sdk >= 2.10.0
BuildRequires:    eclipse-license
Requires:         eclipse-platform >= 1:4.4.0
Requires:         eclipse-emf >= 2.10.0

# Obsoletes/Provides added in F21
Provides:         eclipse-emf-xsd = %{version}-%{release}
Obsoletes:        eclipse-emf-xsd < %{version}-%{release}

%description
The XML Schema Definition (XSD) plug-in is a library that provides an API for
manipulating the components of an XML Schema as described by the W3C XML
Schema specifications, as well as an API for manipulating the DOM-accessible
representation of XML Schema as a series of XML documents.

%package   sdk
Summary:   Eclipse XSD SDK
Requires:  eclipse-pde >= 1:4.4.0
Requires:  eclipse-emf-sdk >= 2.10.0
Requires:  %{name} = %{version}-%{release}

# Obsoletes/Provides added in F21
Provides:  eclipse-emf-xsd-sdk = %{version}-%{release}
Obsoletes: eclipse-emf-xsd-sdk < %{version}-%{release}

%description sdk
Documentation and developer resources for the Eclipse XML Schema Definition
(XSD) plug-in.

%package   examples
Summary:   Eclipse XSD examples
Requires:  %{name}-sdk = %{version}-%{release}

%description examples
Installable versions of the example projects from the SDKs that demonstrate how
to use the XML Schema Definition (XSD) plug-ins.

%prep
%setup -q -n org.eclipse.xsd-%{git_tag}

find -name *.jar -exec rm -rf {} \;
find -name *.class -exec rm -rf {} \;

%patch0 -p1
%patch1 -p1

%build
xmvn -o clean verify

%install
# Install main features
xmvn -o org.fedoraproject:feclipse-maven-plugin:install \
  -Dfeatures=org.eclipse.xsd,org.eclipse.xsd.ecore.converter,org.eclipse.xsd.edit,org.eclipse.xsd.editor,org.eclipse.xsd.mapping,org.eclipse.xsd.mapping.editor \
  -DsourceRepo=releng/org.eclipse.xsd.repository/target/repository \
  -DtargetLocation=%{buildroot}%{eclipse_dropin}/xsd/eclipse

# Install sdk features
xmvn -o org.fedoraproject:feclipse-maven-plugin:install \
  -Dfeatures=org.eclipse.xsd.sdk,org.eclipse.xsd.sdk.source \
  -DsourceRepo=releng/org.eclipse.xsd.repository/target/repository \
  -DtargetLocation=%{buildroot}%{eclipse_dropin}/xsd-sdk/eclipse

# Install example features
xmvn -o org.fedoraproject:feclipse-maven-plugin:install \
  -Dfeatures=org.eclipse.xsd.example \
  -DsourceRepo=releng/org.eclipse.xsd.repository/target/repository \
  -DtargetLocation=%{buildroot}%{eclipse_dropin}/xsd-examples/eclipse

# The main features are a subset of the sdk feature, so delete duplicate features & plugins from the sdk
(cd %{buildroot}%{eclipse_dropin}/xsd-sdk/eclipse/features && ls %{buildroot}%{eclipse_dropin}/xsd/eclipse/features | xargs rm -rf)
(cd %{buildroot}%{eclipse_dropin}/xsd-sdk/eclipse/plugins  && ls %{buildroot}%{eclipse_dropin}/xsd/eclipse/plugins  | xargs rm -rf)

# This plugin is already installed by one of the main features
rm %{buildroot}%{eclipse_dropin}/xsd-examples/eclipse/plugins/org.eclipse.xsd_*

%files
%{eclipse_dropin}/xsd
%doc doc/org.eclipse.xsd.doc/about.html

%files sdk
%{eclipse_dropin}/xsd-sdk

%files examples
%{eclipse_dropin}/xsd-examples

%changelog
* Wed Oct 01 2014 Mat Booth <mat.booth@redhat.com> - 2.10.1-1
- Update to Luna SR1 release
- Drop upstreamed patch

* Wed Aug 13 2014 Mat Booth <mat.booth@redhat.com> - 2.10.0-2
- Qualifier should be lexographically greater than upstream's

* Wed Jun 25 2014 Mat Booth <mat.booth@redhat.com> - 2.10.0-1
- Update to latest upstream release

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.9.2-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Mon Apr 07 2014 Mat Booth <mat.booth@redhat.com> - 2.9.2-2
- Add examples sub-package.

* Wed Mar 12 2014 Mat Booth <mat.booth@redhat.com> - 2.9.2-1
- Initial release of separate XSD package.
